# TownDirectoryWindow Struct Reference

Town directory window class. More...

Inheritance diagram for TownDirectoryWindow:

## Public Member Functions
| TownDirectoryWindow (const WindowDesc *desc)
virtual void | OnPaint ()
| The window must be repainted.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnClick (Point pt, int widget)
| A click with the left mouse button has been made on the window.
virtual void | OnHundredthTick ()
| Called once every 100 (game) ticks.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnInvalidateData (int data)
| Some data on this window has become invalid.
## Private Member Functions
void | BuildSortTownList ()
## Static Private Member Functions
static int CDECL | TownNameSorter (const Town *const *a, const Town *const *b)
| Sort by town name.
static int CDECL | TownPopulationSorter (const Town *const *a, const Town *const *b)
| Sort by population.
## Private Attributes
GUITownList | towns
## Static Private Attributes
static Listing | last_sorting = {false, 0}
static const Town * | last_town = NULL
static GUITownList::SortFunction *const | sorter_funcs []

## Detailed Description

Town directory window class.

Definition at line 641 of file town_gui.cpp.

## Member Function Documentation

virtual void TownDirectoryWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 716 of file town_gui.cpp.

References Window::DrawWidgets().

virtual void TownDirectoryWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 721 of file town_gui.cpp.

References GetWorldPopulation(), and SetDParam().

virtual void TownDirectoryWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 726 of file town_gui.cpp.

References Window::DrawSortButtonState(), DrawString(), Scrollbar::GetCapacity(), Scrollbar::GetPosition(), INVALID_TILE, GUIList< T, F >::IsDescSortOrder(), Rect::left, SmallVector< T, S >::Length(), Rect::right, SBS_DOWN, SBS_UP, SetDParam(), GUIList< T, F >::SortType(), Rect::top, Window::vscroll, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

virtual void TownDirectoryWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 761 of file town_gui.cpp.

References GetStringBoundingBox(), Dimension::height, SmallVector< T, S >::Length(), maxdim(), SetDParam(), WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, WD_SORTBUTTON_ARROW_WIDTH, and Dimension::width.

virtual void TownDirectoryWindow::OnClick | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.

Reimplemented from Window.

Definition at line 800 of file town_gui.cpp.

References _ctrl_pressed, Scrollbar::GetCapacity(), Scrollbar::GetPosition(), SmallVector< T, S >::Length(), Window::SetDirty(), GUIList< T, F >::SetSortType(), GUIList< T, F >::SortType(), GUIList< T, F >::ToggleSortOrder(), Window::vscroll, WD_FRAMERECT_TOP, and Point::y.

virtual void TownDirectoryWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 850 of file town_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and Window::vscroll.

virtual void TownDirectoryWindow::OnInvalidateData | ( | int | data | ) | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | information about the changed data.

Reimplemented from Window.

Definition at line 855 of file town_gui.cpp.

References GUIList< T, F >::ForceRebuild(), and GUIList< T, F >::ForceResort().

## Field Documentation

GUITownList::SortFunction *const TownDirectoryWindow::sorter_funcs`[static, private]`

Initial value:

     {
      &TownNameSorter,
      &TownPopulationSorter,
    }

Definition at line 648 of file town_gui.cpp.

The documentation for this struct was generated from the following file:

- src/town_gui.cpp